//
//  MyOBJ.h
//  ThreeDBase
//
//  Created by Justin Bakse on 1/28/05.
//  Copyright 2005 Justin Bakse. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import <OpenGL/gl.h>
#import <OpenGL/glu.h>



#import "MyTypes.h"
//#import "Vector3D.h"

@interface MyOBJ : NSObject {
    @public //but really, mess with this through the accessors
    Boolean rendersSmooth;
    Boolean  rendersFaces;
    Boolean  rendersWireframes;
    Boolean  rendersNormals;
    Boolean  rendersTextures;
    Boolean displayListDirty;
    char objectName[255];
    
    @protected
    Vector3D mVerts[500000];
    int mVertCount;
    
    Vector3D mNormals[500000];
    int mNormalCount;
    
    Vector3D mTextureVerts[500000];
    int mTextureVertCount;
    
    Face mFaces[500000];
    int mFaceCount;
    
    int displayList;
    int wireframeDisplayList;
}

//public

//file loading
-(void)loadOBJFile:(char *)fileName;

//params
-(void)setRendersSmooth:(Boolean)yn;
-(Boolean)rendersSmooth;
-(void)setRendersFaces:(Boolean)yn;
-(Boolean)rendersFaces;
-(void)setRendersWireframes:(Boolean)yn;
-(Boolean)rendersWireframes;
-(void)setRendersNormals:(Boolean)yn;
-(Boolean)rendersNormals;
-(void)setRendersTextures:(Boolean)yn;
-(Boolean)rendersTextures;




//drawing
-(void)render;


-(void)renderModelAsPoints;

-(void)renderModelAsFlatNormals;
-(void)renderModelAsSmoothNormals;

-(void)renderModelAsFramePolys;

-(void)renderModelAsFlatPolys;
-(void)renderModelAsFlatTexturedPolys;
-(void)renderModelAsSmoothPolys;
-(void)renderModelAsSmoothTexturedPolys;

//private
-(void)readVertex:(char*) line;
-(void)readTextureVertex:(char*) line;
-(void)readNormal:(char*) line;
-(void)readFace:(char*) line;



@end
