//
//  MyOpenGLView.h
//  ThreeDBase
//
//  Created by Justin Bakse on 1/26/05.
//  Copyright 2005 Justin Bakse. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import <AppKit/AppKit.h>
#import <OpenGL/gl.h>
#import <OpenGL/glu.h>
#include <OpenGL/glext.h>

@interface MyOpenGLView : NSOpenGLView
{
    @public
    NSPoint mouseLoc;
    
    @private
    int calcFrames, drawFrames, drawRequests;
    double calcsPerSecond, drawsPerSecond;
    NSTimer *printFPSTimer;
}


//public
- (void)changeToApplicationPath;

//private
- (void)initWorld;
- (void)calcWorld;
- (void)drawWorld:(NSRect)rect;

- (void)initGLParam;
- (void)sizeGLWithWidth: (int)width Height: (int)height;

- (void)startThreads;
- (void)stepCalc:(id)anObject;
- (void)stepDraw:(id)anObject;

- (void)printFPS:(NSTimer *)secondsTimer;






@end
