/*
 *  MyTypes.h
 *  ThreeDBase
 *
 *  Created by Justin Bakse on 1/29/05.
 *  Copyright 2005 Justin Bakse. All rights reserved.
 *
 */

//#include <Carbon/Carbon.h>

#include <math.h>

static const float RADIANS_TO_DEGREES = 180. / 3.1415927;
static const float DEGREES_TO_RADIAN = 3.1415927 / 180.;

typedef struct{
    int verts;
    int v[4];  
    int vt[4];
    int vn[4];  
}Face;



typedef struct{
    float angle;
    float x;  
    float y;
    float z;  
}AxisRotation;


typedef struct {
    float x;
    float y;
    float z;
}Vector3D;




typedef struct {
    float x;
    float y;
    float z;
    float n;
}Quaternion;





//Face

//Axis Rotation
AxisRotation MakeAxisRotationAXYZ(float angle, float x, float y, float z);
AxisRotation MakeAxisRotationAV(float angle, Vector3D v);


//Vector3D
Vector3D MakeVector3D(float x, float y, float z);

float Vector3DMagnitude(Vector3D v1);
Vector3D Vector3DNormalize(Vector3D v1);
Vector3D Vector3DReverse(Vector3D v1);

Vector3D Vector3DAdd(Vector3D v1, Vector3D v2);
Vector3D Vector3DSubtract(Vector3D v1, Vector3D v2);
Vector3D Vector3DScale(Vector3D v1, float scale);
Vector3D Vector3DCross(Vector3D v1, Vector3D v2);
float Vector3DDot(Vector3D v1, Vector3D v2);
float Vector3DGetAngle(Vector3D v1, Vector3D v2);


//Quaternion
Quaternion MakeQuaternion(float n, float x, float y, float z);
Quaternion AxisRotationToQuaternion(AxisRotation a);
AxisRotation QuaternionToAxisRotation(Quaternion q);
Quaternion QuaternionMultiply(Quaternion q0, Quaternion q1);





